> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://docs.getunleash.io/api/clone-environment/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.getunleash.io/_mcp/server. # Clones an environment POST https://app.unleash-instance.example.com/api/admin/environments/{name}/clone Content-Type: application/json **Enterprise feature** Given an existing environment name and a set of options, this will create a copy of that environment Reference: https://docs.getunleash.io/api/clone-environment ## Authentication - `Authorization` header (required) — API key needed to access this API - `Authorization` header (bearer token, required) — API key needed to access this API, in Bearer token format ## Request ### Path parameters - `name` (string, required) ### Body (application/json) This endpoint expects a cloneEnvironmentSchema. - `name` (string, required) — The name of the new cloned environment, this cannot be changed later - `type` (string, required) — Updates the type of environment (i.e. development or production). - `projects` (list of string, optional) — A list of projects that should be included in the cloned environment. - `clonePermissions` (boolean, optional) — Copies the RBAC permissions from the source environment if true. Defaults to true ## Response ### 200 environmentSchema - `name` (string, required) — The name of the environment - `type` (string, required) — The [type of environment](https://docs.getunleash.io/concepts/environments#environment-types). - `enabled` (boolean, required) — `true` if the environment is enabled for the project, otherwise `false`. - `protected` (boolean, required) — `true` if the environment is protected, otherwise `false`. A *protected* environment can not be deleted. - `sortOrder` (integer, required) — Priority of the environment in a list of environments, the lower the value, the higher up in the list the environment will appear. Needs to be an integer - `projectCount` (integer, optional, nullable) — The number of projects with this environment - `apiTokenCount` (integer, optional, nullable) — The number of API tokens for the project environment - `enabledToggleCount` (integer, optional, nullable) — The number of enabled toggles for the project environment - `requiredApprovals` (integer, optional, nullable) — Experimental field. The number of approvals required before a change request can be applied in this environment. ## Errors ### 400 Bad Request Error The request data does not match what we expect. - `id` (string, optional) — The ID of the error instance - `name` (string, optional) — The name of the error kind - `message` (string, optional) — A description of what went wrong. ### 401 Unauthorized Error Authorization information is missing or invalid. Provide a valid API token as the `authorization` header, e.g. `authorization:*.*.my-admin-token`. - `id` (string, optional) — The ID of the error instance - `name` (string, optional) — The name of the error kind - `message` (string, optional) — A description of what went wrong. ## Examples **Request** ```json { "name": "development", "type": "development" } ``` **Response** ```json { "name": "my-dev-env", "type": "development", "enabled": true, "protected": true, "sortOrder": 3, "projectCount": 10, "apiTokenCount": 6, "enabledToggleCount": 10, "requiredApprovals": 3 } ``` **SDK Code** ```python import requests url = "https://app.unleash-instance.example.com/api/admin/environments/name/clone" payload = { "name": "development", "type": "development" } headers = { "Authorization": "", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://app.unleash-instance.example.com/api/admin/environments/name/clone'; const options = { method: 'POST', headers: {Authorization: '', 'Content-Type': 'application/json'}, body: '{"name":"development","type":"development"}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://app.unleash-instance.example.com/api/admin/environments/name/clone" payload := strings.NewReader("{\n \"name\": \"development\",\n \"type\": \"development\"\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Authorization", "") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://app.unleash-instance.example.com/api/admin/environments/name/clone") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = '' request["Content-Type"] = 'application/json' request.body = "{\n \"name\": \"development\",\n \"type\": \"development\"\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://app.unleash-instance.example.com/api/admin/environments/name/clone") .header("Authorization", "") .header("Content-Type", "application/json") .body("{\n \"name\": \"development\",\n \"type\": \"development\"\n}") .asString(); ``` ```php request('POST', 'https://app.unleash-instance.example.com/api/admin/environments/name/clone', [ 'body' => '{ "name": "development", "type": "development" }', 'headers' => [ 'Authorization' => '', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://app.unleash-instance.example.com/api/admin/environments/name/clone"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", ""); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"name\": \"development\",\n \"type\": \"development\"\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = [ "Authorization": "", "Content-Type": "application/json" ] let parameters = [ "name": "development", "type": "development" ] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://app.unleash-instance.example.com/api/admin/environments/name/clone")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```